<?php

/* Copyright (C) 2007-2010 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *   	\file       dev/skeletons/skeleton_page.php
 * 		\ingroup    mymodule othermodule1 othermodule2
 * 		\brief      This file is an example of a php page
 * 					Put here some comments
 */
//if (! defined('NOREQUIREUSER'))  define('NOREQUIREUSER','1');
//if (! defined('NOREQUIREDB'))    define('NOREQUIREDB','1');
//if (! defined('NOREQUIRESOC'))   define('NOREQUIRESOC','1');
//if (! defined('NOREQUIRETRAN'))  define('NOREQUIRETRAN','1');
//if (! defined('NOCSRFCHECK'))    define('NOCSRFCHECK','1');
//if (! defined('NOTOKENRENEWAL')) define('NOTOKENRENEWAL','1');
//if (! defined('NOREQUIREMENU'))  define('NOREQUIREMENU','1');	// If there is no menu to show
//if (! defined('NOREQUIREHTML'))  define('NOREQUIREHTML','1');	// If we don't need to load the html.form.class.php
//if (! defined('NOREQUIREAJAX'))  define('NOREQUIREAJAX','1');
//if (! defined("NOLOGIN"))        define("NOLOGIN",'1');		// If this page is public (can be called outside logged session)
// Change this following line to use the correct relative path (../, ../../, etc)
$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");

require_once(DOL_DOCUMENT_ROOT . "/core/lib/agenda.lib.php");
require_once(DOL_DOCUMENT_ROOT . "/comm/action/class/cactioncomm.class.php");
require_once(DOL_DOCUMENT_ROOT . "/comm/action/class/actioncomm.class.php");
require_once(dirname(__FILE__) . '/class/usermailboxconfig.class.php');
require_once(dirname(__FILE__) . '/lib/lib_dolimapmail.php');


// Change this following line to use the correct relative path from htdocs (do not remove DOL_DOCUMENT_ROOT)
//require_once(DOL_DOCUMENT_ROOT."/../dev/skeleton/skeleton_class.class.php");
// Load traductions files requiredby by page
$langs->load("companies");
$langs->load("other");
$langs->load("dolimapmail@dolimapmail");
$langs->load("agenda");

global $conf;
if ($conf->global->PAGINATION_WEBMAIL)
    $pagination = $conf->global->PAGINATION_WEBMAIL;
else
    $pagination = 20;

if (empty($_GET['num_page']))
    $_GET['num_page'] = 1;

// Get parameters
$id = GETPOST('id', 'int');
$action = GETPOST('action', 'alpha');
$folder = urldecode(GETPOST('folder', 'alpha'));
$mesg = GETPOST('mesg', 'alpha');

// Protection if external user
if ($user->societe_id > 0) {
    accessforbidden();
}

if (!(extension_loaded("IMAP"))) {
    llxHeader('', 'Dolibarr Webmail', '');

    $head[0][0] = dol_buildpath('/dolimapmail/index.php', 1);
    $head[0][1] = $langs->trans("DolimapmailMailbox");
    $head[0][2] = 'mailbox';
    if (function_exists('setEventMessage')) {
        setEventMessage($langs->trans('Erreur : Module Imap non chargé'),
                'errors');
    }
    else {
        $errors[] = $langs->trans('Erreur : Module Imap non chargé');
        dol_htmloutput_errors('', $errors);
    }
    dol_fiche_head($head, 'mailbox', $langs->trans("Webmail"), 0,
            'mailbox@dolimapmail');
}
else {

    $mailboxconfig = new Usermailboxconfig($db);
    $mailboxconfig->fetch_from_user($user->id);

    $user->mailbox_imap_login = $mailboxconfig->mailbox_imap_login;
    $user->mailbox_imap_password = $mailboxconfig->mailbox_imap_password;
    $user->mailbox_imap_host = $mailboxconfig->mailbox_imap_host;
    $user->mailbox_imap_port = $mailboxconfig->mailbox_imap_port;
    $user->mailbox_imap_ssl = $mailboxconfig->mailbox_imap_ssl;
    $user->mailbox_imap_ssl_novalidate_cert = $mailboxconfig->mailbox_imap_ssl_novalidate_cert;
    $user->mailbox_imap_ref = $mailboxconfig->get_ref();
    $user->mailbox_imap_connector_url = $mailboxconfig->get_connector_url();

    if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_connect')) {
        $memcache_obj = memcache_connect('localhost',
                $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_PORT);
    }
    else {
        $memcache_obj = FALSE;
    }
    if (GETPOST('action') === 'markasunreadmail') {
        if (GETPOST('uid') != '') {
            $liste_uid[0] = GETPOST('uid');
        }
        else {
            $liste_uid = GETPOST('list_uid');
        }
        $nb_uid = sizeof($liste_uid);
        $mbox = @imap_open($user->mailbox_imap_connector_url . $folder,
                        $user->mailbox_imap_login, $user->mailbox_imap_password);
        if (FALSE === $mbox) {
            $info = FALSE;
            if (function_exists('setEventMessage')) {
                setEventMessage($langs->trans('connexion_failed'), 'errors');
            }
            else {
                $errors[] = $langs->trans('connexion_failed');
            }
        }
        else {
            for ($i = 0; $i < $nb_uid; $i++) {
                imap_clearflag_full($mbox, $liste_uid[$i], "\\Seen", ST_UID);
            }
            @imap_close($mbox);
            $_GET['action'] = 'refresh';
        }
    }
    elseif (GETPOST('action') === 'markasreadmail') {
        if (GETPOST('uid') != '') {
            $liste_uid[0] = GETPOST('uid');
        }
        else {
            $liste_uid = GETPOST('list_uid');
        }
        $nb_uid = sizeof($liste_uid);
        $mbox = @imap_open($user->mailbox_imap_connector_url . $folder,
                        $user->mailbox_imap_login, $user->mailbox_imap_password);
        if (FALSE === $mbox) {
            $info = FALSE;
            if (function_exists('setEventMessage')) {
                setEventMessage($langs->trans('connexion_failed'), 'errors');
            }
            else {
                $errors[] = $langs->trans('connexion_failed');
            }
        }
        else {
            for ($i = 0; $i < $nb_uid; $i++) {
                imap_setflag_full($mbox, $liste_uid[$i], "\\Seen", ST_UID);
            }
            @imap_close($mbox);
            $_GET['action'] = 'refresh';
        }
    }
    elseif (GETPOST('action') === 'deletemail') {
        $liste_uid = GETPOST('list_uid');
        $nb_uid = sizeof($liste_uid);
        $mbox = @imap_open($user->mailbox_imap_connector_url . $folder,
                        $user->mailbox_imap_login, $user->mailbox_imap_password);
        if (FALSE === $mbox) {
            $info = FALSE;
            if (function_exists('setEventMessage')) {
                setEventMessage($langs->trans('connexion_failed'), 'errors');
            }
            else {
                $errors[] = $langs->trans('connexion_failed');
            }
        }
        else {
            for ($i = 0; $i < $nb_uid; $i++) {
                //imap_setflag_full($mbox, $liste_uid[$i], "\\Deleted", ST_UID);
                if (imap_mail_move($mbox, $liste_uid[$i], 'Trash', CP_UID) == FALSE)
                    $error = 1;
            }
            @imap_close($mbox);
            if ($error) {
                if (function_exists('setEventMessage')) {
                    setEventMessage($langs->trans('move_into_trash_failed'),
                            'errors');
                }
                else {
                    $errors[] = $langs->trans('move_into_trash_failed');
                }
            }
            else {
                if (function_exists('setEventMessage')) {
                    setEventMessage($langs->trans('move_into_trash_ok'), 'mesgs');
                }
                else {
                    $mesgs[] = $langs->trans('move_into_trash_ok');
                }
            }
            $_GET['action'] = 'refresh';
        }
    }
    $form = new Form($db);

    if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_flush')
            && GETPOST('action') === 'refresh') {
        memcache_flush($memcache_obj);
    }
    if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_get')) {
        $mails = memcache_get($memcache_obj,
                $user->id . '_dolimapmail_mails_' . $folder . '_' . $pagination . '_' . GETPOST('num_page'));
        $info = memcache_get($memcache_obj,
                $user->id . '_dolimapmail_info_' . $folder);
    }
    else {
        $mails = FALSE;
        $info = FALSE;
    }

    // Connexion
    if (!$memcache_obj || !$mails || !$info) {
        $mbox = @imap_open($user->mailbox_imap_connector_url . $folder,
                        $user->mailbox_imap_login, $user->mailbox_imap_password);
        if (FALSE === $mbox) {
            $info = FALSE;
            if (function_exists('setEventMessage')) {
                setEventMessage($langs->trans('connexion_failed'), 'errors');
            }
            else {
                $errors[] = $langs->trans('connexion_failed');
            }
        }
        else {
            //$info = @imap_mailboxmsginfo($mbox);
            $info = imap_status($mbox,
                    $user->mailbox_imap_connector_url . $folder, SA_MESSAGES);
            if (FALSE !== $info) {
                //$nb_messages = $info->Nmsgs;
                $nb_messages = $info->messages;
                $indice_msgend = $nb_messages - ($pagination * (GETPOST('num_page')
                        - 1));
                $indice_msgbegin = max(1, $indice_msgend - $pagination + 1);
                $mails = imap_fetch_overview($mbox,
                        $indice_msgbegin . ':' . $indice_msgend, 0);
                if ($conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE && function_exists('memcache_set')) {
                    $res_add = memcache_set($memcache_obj,
                            $user->id . '_dolimapmail_mails_' . $folder . '_' . $pagination . '_' . GETPOST('num_page'),
                            $mails, 0,
                            $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_TTL);
                    $res_add = memcache_set($memcache_obj,
                            $user->id . '_dolimapmail_info_' . $folder, $info,
                            0, $conf->global->DOLIMAPMAIL_SERVEUR_MEMCACHE_TTL);
                }
            }
            else {
                if (function_exists('setEventMessage')) {
                    setEventMessage($langs->trans('mailboxmsginfo_failed'),
                            'errors');
                }
                else {
                    $errors[] = $langs->trans('mailboxmsginfo_failed');
                }
            }
            @imap_close($mbox);
        }
    }

    if ($folder == '')
        $folder = 'INBOX';

    /*     * *************************************************
     * VIEW
     *
     * Put here all code to build page
     * ************************************************** */

    llxHeader('', 'Dolibarr Webmail', '');

    $head[0][0] = dol_buildpath('/dolimapmail/index.php', 1) . '?mainmenu=dolimapmail';
    $head[0][1] = $langs->trans("DolimapmailMailbox");
    $head[0][2] = 'mailbox';

    dol_fiche_head($head, 'mailbox', $langs->trans("Webmail"), 0,
            'mailbox@dolimapmail');

    if (!(function_exists('setEventMessage'))) {
        dol_htmloutput_mesg($mesg, $mesgs);
        dol_htmloutput_errors('', $errors);
    }

    print '<div style="float:left;">';
    print '<div class="inline-block divButAction"><a class="butAction" href="' . dol_buildpath('/dolimapmail/newmail.php',
                    1) . '?mainmenu=dolimapmail&folder=' . $folder . '&mode=init">' . $langs->trans('newmail') . '</a></div>';
    print '<div class="inline-block divButAction"><a class="butAction" href="' . $_SERVER["PHP_SELF"] . '?mainmenu=dolimapmail&folder=' . GETPOST('folder') . '&num_page=' . $page_precedente . '&action=refresh">' . $langs->trans('Refresh') . '</a></div>';
    print '<div class="inline-block divButAction"><a class="butAction" href="javascript:;" onclick="document.getElementById(\'action\').value=\'deletemail\';document.forms.frm_liste_mails.submit();">' . $langs->trans('deletemail') . '</a></div>';
    print '<div class="inline-block divButAction"><a class="butAction" href="javascript:;" onclick="document.getElementById(\'action\').value=\'markasreadmail\';document.forms.frm_liste_mails.submit();">' . $langs->trans('markasreadmail') . '</a></div>';
    print '<div class="inline-block divButAction"><a class="butAction" href="javascript:;" onclick="document.getElementById(\'action\').value=\'markasunreadmail\';document.forms.frm_liste_mails.submit();">' . $langs->trans('markasunreadmail') . '</a></div>';
    print '</div>';

    $str_pagination = '';

    $page_precedente = GETPOST("num_page") - 1;
    $page_suivante = GETPOST("num_page") + 1;
    if ($page_precedente > 0)
        $str_pagination .= '<a href="' . dol_buildpath('/dolimapmail/index.php',
                        1) . '?mainmenu=dolimapmail&folder=' . GETPOST('folder') . '&num_page=' . $page_precedente . '">' . $langs->trans('Precedente') . '</a> ';
    //$nb_messages = $info->Nmsgs;
    $nb_messages = $info->messages;
    $nb_pages = ceil($nb_messages / $pagination);

    for ($num_page = 1; $num_page <= $nb_pages; $num_page++) {
        if ($num_page <= 3 || $num_page === GETPOST("num_page") - 1 || $num_page
                === GETPOST("num_page") || $num_page === GETPOST("num_page") + 1
                || $num_page === $nb_pages - 1 || $num_page === $nb_pages) {
            $affiche = 1;
            if ($num_page != GETPOST("num_page"))
                $str_pagination .= '<a href="' . dol_buildpath('/dolimapmail/index.php',
                                1) . '?mainmenu=dolimapmail&folder=' . GETPOST('folder') . '&num_page=' . $num_page . '">' . $num_page . '</a> ';
            else
                $str_pagination .= '<span id="selected">' . $num_page . '</span>';

            if ($num_page < $nb_pages)
                $str_pagination .= ', ';
        }
        else {
            if ($affiche)
                $str_pagination .= '... , ';
            $affiche = 0;
        }
    }

    if ($page_suivante < $nb_pages)
        $str_pagination .= '<a href="' . dol_buildpath('/dolimapmail/index.php',
                        1) . '?mainmenu=dolimapmail&folder=' . GETPOST('folder') . '&num_page=' . $page_suivante . '">' . $langs->trans('Suivante') . '</a> ';

    print '<div style="float:right;">' . $str_pagination . '</div><div style="clear:both;"></div>';

    print '<form id="frm_liste_mails" name="frm_liste_mails" method="POST" action="' . $_SERVER["PHP_SELF"] . '">';
    print '<input type="hidden" name="action" id="action" value="" />';
    print '<input type="hidden" name="mainmenu" value="dolimapmail" />';
    print '<input type="hidden" name="folder" value="' . GETPOST('folder') . '" />';
    print '<input type="hidden" name="num_page" value="' . GETPOST('num_page') . '" />';
    print '<table class="noborder" width="100%">';
    print '<tr class="liste_titre">';
    print_liste_field_titre($langs->trans("DolimapmaillObject"), '', "", '', '',
            'align="center" colspan="7"', '', '', ' ');
    print_liste_field_titre($langs->trans("DolimapmaillFrom"), '', "", '', '',
            'align="center"', '', '', ' ');
    print_liste_field_titre($langs->trans("DolimapmaillDate"), '', "", '', '',
            'align="center"', '', '', ' ');
    print_liste_field_titre($langs->trans("DolimapmaillTaille"), '', "", '', '',
            'align="center"', '', '', ' ');
    print '    </tr>';
    if ($mails)
        $nb_mails = sizeof($mails);
    if ($conf->global->DOLIMAPMAIL_DEBUG_MAIL_ENCODAGE) {
        print 'Nb Mails trouvés : ' . $nb_mails;
    }
    for ($i = $nb_mails - 1; $i >= 0; $i--) {
        $mail = $mails[$i];
//        if ($mail->deleted == 0) {
            if (!isset($mail->subject) || trim($mail->subject) === '')
                $mail->subject = $langs->trans('[ Empty subject ]');
            print '    <tr class="';
            if ($i % 2 === 0)
                print 'impair ';
            else
                print 'pair ';
            if ($mail->seen)
                print 'seen ';
            else
                print 'unseen ';
            if ($mail->deleted)
                print 'mail_deleted ';
            
            print '">';
            print '<td style="text-align:center;width:30px;">';
            print '<input type="checkbox" name="list_uid[]" value="' . $mail->uid . '" />';
            print '</td>';
            print '<td>' . "\n";
            if ($conf->global->DOLIMAPMAIL_LINKTO) {
                $nb_linked = getnb_linked($mail);
                if ($nb_linked)
                    print img_picto('(' . $nb_linked . ' Liens)',
                                    'linked@dolimapmail');
            }
            print '</td>' . "\n";
            print '<td style="text-align:center;width:30px;">';
            if ($mail->answered && !$mail->forwarded)
                print img_picto($langs->trans('answered'),
                                'answered@dolimapmail');
            else if ($mail->forwarded && !$mail->answered)
                print img_picto($langs->trans('forwarded'),
                                'forwarded@dolimapmail');
            else if ($mail->forwarded && $mail->answered)
                print img_picto($langs->trans('answeredforwarded'),
                                'answeredforwarded@dolimapmail');
            print '</td>';
            print '<td>' . "\n";
            print '</td>' . "\n";
            print '<td align="center">';
            if ($mail->flagged)
                print img_picto($langs->trans('flagged'), 'flagged@dolimapmail');
            else
                print img_picto($langs->trans('unflagged'),
                                'unflagged@dolimapmail');
            print '</td>' . "\n";
            print '<td><a href="' . dol_buildpath('/dolimapmail/detail.php', 1) . '?mainmenu=dolimapmail&uid=' . $mail->uid . ($folder
                    != '' ? '&folder=' . $folder : '') . '&key=' . sha1(serialize_mail($mail)) . '&mode=init">' . trim(utf8_encode(@iconv_mime_decode(imap_utf8($mail->subject)))) . '</a></td>';

            print '<td style="text-align:center;width:30px;">';
            if ($mail->seen)
                print '<a href="' . dol_buildpath('/dolimapmail/index.php', 1) . '?mainmenu=dolimapmail&uid=' . $mail->uid . ($folder
                        != '' ? '&folder=' . $folder : '') . '&action=markasunreadmail" >' . img_picto($langs->trans('markasunreadmail'),
                                'seen@dolimapmail') . '</a>';
            else
                print '<a href="' . dol_buildpath('/dolimapmail/index.php', 1) . '?mainmenu=dolimapmail&uid=' . $mail->uid . ($folder
                        != '' ? '&folder=' . $folder : '') . '&action=markasreadmail" >' . img_picto($langs->trans('markasreadmail'),
                                'unseen@dolimapmail') . '</a>';
            print '</td>';
            print '<td>' . trim(utf8_encode(preg_replace('/<.*>|"/', '',
                                            @iconv_mime_decode(imap_utf8($mail->from))))) . '</td>';
            print '<td style="text-align:center;width: 115px;">' . date("d/m/Y H:i",
                            strtotime($mail->date)) . '</td>';
            if ($mail->size < 1024) {
                $unit = '&nbsp;o.';
            }
            elseif ($mail->size / 1024 > 1024) {
                $mail->size = $mail->size / 1048576; // 1048576 = 1024 / 1024;
                $unit = '&nbsp;Mo.';
            }
            else {
                $mail->size = $mail->size / 1024;
                $unit = '&nbsp;Ko.';
            }
            print '<td style="text-align:right;">' . number_format($mail->size,
                            2) . $unit . '</td>';
            print '</tr>' . "\n";
//        }
    }
    print '</table>';
    print '</form>';

    print '<div style="float:right;">' . $str_pagination . '</div><div style="clear:both;"></div>';
    if ($mbox)
        @imap_close($mbox);
}

// End of page
llxFooter();
$db->close();
