<?php

/* Copyright (C) 2007-2010 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

/**
 *   	\file       dev/skeletons/skeleton_page.php
 * 		\ingroup    mymodule othermodule1 othermodule2
 * 		\brief      This file is an example of a php page
 * 					Put here some comments
 */
//if (! defined('NOREQUIREUSER'))  define('NOREQUIREUSER','1');
//if (! defined('NOREQUIREDB'))    define('NOREQUIREDB','1');
//if (! defined('NOREQUIRESOC'))   define('NOREQUIRESOC','1');
//if (! defined('NOREQUIRETRAN'))  define('NOREQUIRETRAN','1');
//if (! defined('NOCSRFCHECK'))    define('NOCSRFCHECK','1');
//if (! defined('NOTOKENRENEWAL')) define('NOTOKENRENEWAL','1');
//if (! defined('NOREQUIREMENU'))  define('NOREQUIREMENU','1');	// If there is no menu to show
//if (! defined('NOREQUIREHTML'))  define('NOREQUIREHTML','1');	// If we don't need to load the html.form.class.php
//if (! defined('NOREQUIREAJAX'))  define('NOREQUIREAJAX','1');
//if (! defined("NOLOGIN"))        define("NOLOGIN",'1');		// If this page is public (can be called outside logged session)
// Change this following line to use the correct relative path (../, ../../, etc)
$res = 0;
if (!$res && file_exists("../main.inc.php"))
    $res = @include("../main.inc.php");
if (!$res && file_exists("../../main.inc.php"))
    $res = @include("../../main.inc.php");
if (!$res && file_exists("../../../main.inc.php"))
    $res = @include("../../../main.inc.php");
if (!$res && file_exists("../../../../main.inc.php"))
    $res = @include("../../../../main.inc.php");
if (!$res && file_exists("../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../dolibarr/htdocs/main.inc.php");     // Used on dev env only
if (!$res && file_exists("../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res && file_exists("../../../../../dolibarr/htdocs/main.inc.php"))
    $res = @include("../../../../../dolibarr/htdocs/main.inc.php");   // Used on dev env only
if (!$res)
    die("Include of main fails");
// Change this following line to use the correct relative path from htdocs (do not remove DOL_DOCUMENT_ROOT)
//require_once(DOL_DOCUMENT_ROOT."/../dev/skeleton/skeleton_class.class.php");
// Load traductions files requiredby by page
require_once(DOL_DOCUMENT_ROOT . "/core/lib/agenda.lib.php");
require_once(DOL_DOCUMENT_ROOT . "/comm/action/class/cactioncomm.class.php");
require_once(DOL_DOCUMENT_ROOT . "/comm/action/class/actioncomm.class.php");
require_once(dirname(__FILE__) . '/class/usermailboxconfig.class.php');
require_once(dirname(__FILE__) . '/lib/lib_dolimapmail.php');
$langs->load("companies");
$langs->load("other");
$langs->load("dolimapmail@dolimapmail");

// Get parameters
$id = GETPOST('id', 'int');
$action = GETPOST('action', 'alpha');
$folder = GETPOST('folder', 'alpha');
$key = GETPOST('key', 'alpha');
$mesg = GETPOST('mesg');

// Protection if external user
if ($user->societe_id > 0) {
    //accessforbidden();
}

$mailboxconfig = new Usermailboxconfig($db);
$mailboxconfig->fetch_from_user($user->id);

$user->mailbox_imap_login = $mailboxconfig->mailbox_imap_login;
$user->mailbox_imap_password = $mailboxconfig->mailbox_imap_password;
$user->mailbox_imap_host = $mailboxconfig->mailbox_imap_host;
$user->mailbox_imap_port = $mailboxconfig->mailbox_imap_port;
$user->mailbox_imap_ssl = $mailboxconfig->mailbox_imap_ssl;
$user->mailbox_imap_ssl_novalidate_cert = $mailboxconfig->mailbox_imap_ssl_novalidate_cert;
$user->mailbox_imap_ref = $mailboxconfig->get_ref();
$user->mailbox_imap_connector_url = $mailboxconfig->get_connector_url();

if ($action)
    $_GET['mode'] = '';

/*
 * Add file in email form
 */
if (GETPOST('addfile')) {
    require_once DOL_DOCUMENT_ROOT . '/core/lib/files.lib.php';

    // Set tmp user directory TODO Use a dedicated directory for temp mails files
    $vardir = $conf->user->dir_output . "/" . $user->id;
    $upload_dir_tmp = $vardir . '/temp';

    dol_add_file_process($upload_dir_tmp, 0, 0);
    $action = 'presend';
}

/*
 * Remove file in email form
 */
if (GETPOST('removedfile')) {
    require_once DOL_DOCUMENT_ROOT . '/core/lib/files.lib.php';

    // Set tmp user directory
    $vardir = $conf->user->dir_output . "/" . $user->id;
    $upload_dir_tmp = $vardir . '/temp';

    // TODO Delete only files that was uploaded from email form
    dol_remove_file_process(GETPOST('removedfile'), 0);
    $action = 'presend';
}


/*
 * Send mail
 */
if ($action === 'send' && !GETPOST('addfile') && !GETPOST('removedfile') && !GETPOST('cancel')) {
    $langs->load('mails');

    if (GETPOST('sendto')) {
        // Le destinataire a ete fourni via le champ libre
        $sendto = GETPOST('sendto');
        $sendtoid = 0;
    }

    if (dol_strlen($sendto)) {
        $langs->load("commercial");

        $from = GETPOST('fromname') . ' <' . GETPOST('frommail') . '>';
        $replyto = GETPOST('replytoname') . ' <' . GETPOST('replytomail') . '>';
        $message = GETPOST('message');
        $sendtocc = GETPOST('sendtocc');
        $deliveryreceipt = GETPOST('deliveryreceipt');

        if ($action === 'send') {
            if (dol_strlen(GETPOST('subject')))
                $subject = GETPOST('subject');
            else
                $subject = ' ';
            $actiontypecode = 'AC_COM';
            $actionmsg = $langs->transnoentities('MailSentBy') . ' ' . $from . ' ' . $langs->transnoentities('To') . ' ' . $sendto . ".\n";
            if ($message) {
                $actionmsg.=$langs->transnoentities('MailTopic') . ": " . $subject . "\n";
                $actionmsg.=$langs->transnoentities('TextUsedInTheMessageBody') . ":\n";
                $actionmsg.=$message;
            }
            $actionmsg2 = $langs->transnoentities('Action' . $actiontypecode);
        }

        // Create form object
        include_once DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php';
        $formmail = new FormMail($db);

        $attachedfiles = $formmail->get_attached_files();
        $filepath = $attachedfiles['paths'];
        $filename = $attachedfiles['names'];
        $mimetype = $attachedfiles['mimes'];

        // Send mail
        require_once DOL_DOCUMENT_ROOT . '/core/class/CMailFile.class.php';
        $mailfile = new CMailFile($subject, $sendto, $from, $message, $filepath, $mimetype, $filename, $sendtocc, '', $deliveryreceipt, -1);

        if ($mailfile->error) {
            if (function_exists('setEventMessage')) {
                setEventMessage($mailfile->error, 'errors');
            } else {
                $mesg = '<div class="error">' . $mailfile->error . '</div>';
            }
        } else {
            $result = $mailfile->sendfile();
            if ($result) {
                if (function_exists('setEventMessage')) {
                    setEventMessage($langs->trans('MailSuccessfulySent', $mailfile->getValidAddress($from, 2), $mailfile->getValidAddress($sendto, 2)), 'mesgs');
                } else {
                    $mesg = $langs->trans('MailSuccessfulySent', $mailfile->getValidAddress($from, 2), $mailfile->getValidAddress($sendto, 2)); // Must not contains "
                }
                if (!$mailfile->error) {

                    if ($mailfile->headers == '')
                    {
                        
			// Use mail php function (default PHP method)
			// ------------------------------------------

			$smtp_headers = "";
			$mime_headers = "";
			$text_body = "";
			$files_encoded = "";

			// Define smtp_headers
			$mailfile->subject = $subject;
			$mailfile->addr_from = $from;
			$mailfile->message = $message;
//			$mailfile->errors_to = $errors_to;
			$mailfile->addr_to = $sendto;
			$mailfile->addr_cc = $sendtocc;
//			$mailfile->addr_bcc = $addr_bcc;
			$mailfile->deliveryreceipt = $deliveryreceipt;
//			$mailfile->trackid = $trackid;
			$smtp_headers = $mailfile->write_smtpheaders();

			// Define mime_headers
			$mime_headers = $mailfile->write_mimeheaders($filepath, $mimetype);

                        // We now define $this->headers and $this->message
			$mailfile->headers = $smtp_headers . $mime_headers;
			// On nettoie le header pour qu'il ne se termine pas par un retour chariot.
			// Ceci evite aussi les lignes vides en fin qui peuvent etre interpretees
			// comme des injections mail par les serveurs de messagerie.
			$mailfile->headers = preg_replace("/([\r\n]+)$/i","",$mailfile->headers);
                    }
                    $mailfile->message = stripslashes($mailfile->message);                    
                    
                    $msg_prepared = $mailfile->headers . $mailfile->eol;
                    if (strpos($mailfile->headers, "To: ") === FALSE)
                        $msg_prepared .= "To: " . $mailfile->getValidAddress($sendto, 0, 1) . $mailfile->eol2;
                    $msg_prepared .= "Subject: ".$mailfile->subject . $mailfile->eol;
                    $msg_prepared .= $mailfile->eol;
                    $msg_prepared .= $mailfile->message . $mailfile->eol;

                    if ($conf->global->DOLIMAPMAIL_COPY_SENT_MAIL)
                        store_email_into_folder($msg_prepared, $conf->global->DOLIMAPMAIL_FOLDER_COPY_SENT_MAIL);

                    $formmail->clear_attached_files();
                    // Redirect here
                    // This avoid sending mail twice if going out and then back to page
                    header('Location: index.php?&mesg=' . urlencode($mesg));
                    exit;
                }
                $error = 0;

                if ($error) {
                    dol_print_error($db);
                } else {
                    // Redirect here
                    // This avoid sending mail twice if going out and then back to page
                    header('Location: index.php?mesg=' . urlencode($mesg));
                    exit;
                }
            } else {
                $langs->load("other");

                if (function_exists('setEventMessage')) {
                    if ($mailfile->error) {
                        $mesg.=$langs->trans('ErrorFailedToSendMail', $from, $sendto);
                        $mesg.='<br>' . $mailfile->error;
                    } else {
                        $mesg.=$langs->trans('no_mail_sent_main_disable_all_mails');
                    }
                    setEventMessage($mesg, 'errors');
                } else {
                    $mesg = '<div class="error">';
                    if ($mailfile->error) {
                        $mesg.=$langs->trans('ErrorFailedToSendMail', $from, $sendto);
                        $mesg.='<br>' . $mailfile->error;
                    } else {
                        $mesg.=$langs->trans('no_mail_sent_main_disable_all_mails');
                    }
                    $mesg.='</div>';
                }
            }
        }
    } else {
        $langs->load("errors");
        if (function_exists('setEventMessage')) {
            setEventMessage($langs->trans('Destinataire manquant'), 'errors');
        } else {
            $mesg = '<div class="error">' . $langs->trans('Destinataire manquant') . '</div>';
        }
        dol_syslog('Destinataire manquant');
    }
}


/* * *************************************************
 * VIEW
 *
 * Put here all code to build page
 * ************************************************** */
llxHeader('', 'Dolibarr Webmail', '');

$head[0][0] = dol_buildpath('/dolimapmail/index.php', 1) . '?mainmenu=dolimapmail&folder=' . GETPOST('folder');
$head[0][1] = $langs->trans("DolimapmailListeOfMessages");
$head[0][2] = 'mailbox';

$head[1][0] = $_SERVER['PHP_SELF'] . '?mainmenu=dolimapmail&folder=' . GETPOST('folder');
$head[1][1] = $langs->trans("DolimapmailNewmail");
$head[1][2] = 'newmail';

if (!(function_exists('setEventMessage'))) {
    dol_htmloutput_mesg($mesg, $mesgs);
    dol_htmloutput_errors('', $errors);
}
dol_fiche_head($head, 'newmail', $langs->trans("Webmail"), 0, 'mailbox@dolimapmail');

print '<div class="fichecenter">';
print '<table class="noborder" width="100%">';
print '<tr class="liste_titre">';
print '<th class="liste_titre" colspan="3">' . $langs->trans('DolimapmailNewmail') . '</th>';
print '</tr>';

// Cree l'objet formulaire mail
include_once DOL_DOCUMENT_ROOT . '/core/class/html.formmail.class.php';
$formmail = new FormMail($db);
$formmail->fromtype = 'user';
$formmail->fromid = $user->id;
$formmail->fromname = $user->getFullName($langs);
$formmail->frommail = $user->email;
$formmail->withfrom = 1;
$formmail->withto = 1;
$formmail->withtoccc = $conf->global->MAIN_EMAIL_USECCC;
$formmail->withtopic = 1;
$formmail->withfile = 2;
$formmail->withbody = '__SIGNATURE__';
$formmail->withdeliveryreceipt = 1;
$formmail->withcancel = 1;
// Tableau des substitutions
$formmail->substit['__SIGNATURE__'] = $user->signature;
$formmail->substit['__PERSONALIZED__'] = '';
$formmail->substit['__CONTACTCIVNAME__'] = '';

$custcontact = '';

// Tableau des parametres complementaires
$formmail->param['action'] = 'send';
$formmail->param['models'] = 'mail_send';
//$formmail->param['returnurl'] = dol_buildpath('/dolimapmail/index.php', 1) . '?mainmenu=dolimapmail&folder=' . GETPOST('folder');
// Init list of files
if (GETPOST("mode") === 'init') {
    $formmail->clear_attached_files();
}
print '<tr ' . $bc[$var] . '>';
print '<td class="nowrap" colspan="3">';

// Show form
$formmail->show_form();
print '</td>';
print '</tr>';
print '</table>';

print '<br />';
print '<br />';

// End of page
llxFooter();
$db->close();